//+------------------------------------------------------------------+
//|                                                Interpolation.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

#define ArrowName "Interpolation"

extern int Forward=2;
extern int ArrowSize=3;
extern int Price=0;    // Applied price
                       // 0 - Close
                       // 1 - Open
                       // 2 - High
                       // 3 - Low
                       // 4 - Median
                       // 5 - Typical
                       // 6 - Weighted  

double Buff[];

void DrawArrows()
{
 int FirstWBar=WindowFirstVisibleBar();
 int LastWBar=FirstWBar-WindowBarsPerChart();
 int MiddleWBar=(FirstWBar+LastWBar)/2;
 if (ObjectFind(ArrowName+"S")==-1)
 {
  ObjectCreate(ArrowName+"S", OBJ_ARROW, 0, Time[MiddleWBar+2], Close[MiddleWBar+2]);
  ObjectSet(ArrowName+"S", OBJPROP_ARROWCODE, 251);
  ObjectSet(ArrowName+"S", OBJPROP_WIDTH, ArrowSize);
 }
 if (ObjectFind(ArrowName+"E")==-1)
 {
  ObjectCreate(ArrowName+"E", OBJ_ARROW, 0, Time[MiddleWBar-2], Close[MiddleWBar-2]);
  ObjectSet(ArrowName+"E", OBJPROP_ARROWCODE, 251);
  ObjectSet(ArrowName+"E", OBJPROP_WIDTH, ArrowSize);
 }
 return;
}

int GetStartPoint()
{
 if (ObjectFind(ArrowName+"S")!=-1)
 {
  datetime StartPointTime=ObjectGet(ArrowName+"S", OBJPROP_TIME1);
  return (iBarShift(NULL, 0, StartPointTime));
 }
 else
 {
  return (-1);
 }
}

int GetEndPoint()
{
 if (ObjectFind(ArrowName+"E")!=-1)
 {
  datetime StartPointTime=ObjectGet(ArrowName+"E", OBJPROP_TIME1);
  return (iBarShift(NULL, 0, StartPointTime));
 }
 else
 {
  return (-1);
 }
}


int init()
  {
   SetIndexBuffer(0,Buff);
   SetIndexStyle(0,DRAW_LINE);
   IndicatorDigits(Digits);
   
   DrawArrows();

   return(0);
  }

int deinit()
  {
   ObjectDelete(ArrowName+"S");
   ObjectDelete(ArrowName+"E");
   return(0);
  }

int start()
  {
   DrawArrows();
   ArrayInitialize(Buff, EMPTY_VALUE);
   
   int StartBar=GetStartPoint();
   int EndBar=GetEndPoint();
   if (StartBar<EndBar)
   {
    int A=StartBar;
    StartBar=EndBar;
    EndBar=A;
   }
   
   int i1, i2, i3;
   for (i1=StartBar;i1>=EndBar-Forward;i1--)
   {
    double v1=0;
    for (i2=StartBar;i2>=EndBar;i2--)
    {
     double v2=1;
     double v3=1;
     for (i3=StartBar;i3>=EndBar;i3--)
     {
      if (i2!=i3)
      {
       v2=v2*(i1-i3);
       v3=v3*(i2-i3);
      }
     }
     v1=v1+iMA(NULL, 0, 1, 0, MODE_SMA, Price, i2)*v2/v3;
    }
    Buff[i1]=v1;
   }
   

   return(0);
  }

